# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::Customvisiontraining::V2_0
  module Models
    #
    # Represents the detailed performance data for a trained iteration
    #
    class IterationPerformance

      include MsRestAzure

      # @return [Array<TagPerformance>] Gets the per-tag performance details
      # for this iteration
      attr_accessor :per_tag_performance

      # @return [Float] Gets the precision
      attr_accessor :precision

      # @return [Float] Gets the standard deviation for the precision
      attr_accessor :precision_std_deviation

      # @return [Float] Gets the recall
      attr_accessor :recall

      # @return [Float] Gets the standard deviation for the recall
      attr_accessor :recall_std_deviation

      # @return [Float] Gets the average precision when applicable
      attr_accessor :average_precision


      #
      # Mapper for IterationPerformance class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'IterationPerformance',
          type: {
            name: 'Composite',
            class_name: 'IterationPerformance',
            model_properties: {
              per_tag_performance: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'perTagPerformance',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'TagPerformanceElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'TagPerformance'
                      }
                  }
                }
              },
              precision: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'precision',
                type: {
                  name: 'Double'
                }
              },
              precision_std_deviation: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'precisionStdDeviation',
                type: {
                  name: 'Double'
                }
              },
              recall: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'recall',
                type: {
                  name: 'Double'
                }
              },
              recall_std_deviation: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'recallStdDeviation',
                type: {
                  name: 'Double'
                }
              },
              average_precision: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'averagePrecision',
                type: {
                  name: 'Double'
                }
              }
            }
          }
        }
      end
    end
  end
end
