# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::Customvisiontraining::V3_0
  module Models
    #
    # Image model to be sent as JSON.
    #
    class Image

      include MsRestAzure

      # @return Id of the image.
      attr_accessor :id

      # @return [DateTime] Date the image was created.
      attr_accessor :created

      # @return [Integer] Width of the image.
      attr_accessor :width

      # @return [Integer] Height of the image.
      attr_accessor :height

      # @return [String] The URI to the (resized) image used for training.
      attr_accessor :resized_image_uri

      # @return [String] The URI to the thumbnail of the original image.
      attr_accessor :thumbnail_uri

      # @return [String] The URI to the original uploaded image.
      attr_accessor :original_image_uri

      # @return [Array<ImageTag>] Tags associated with this image.
      attr_accessor :tags

      # @return [Array<ImageRegion>] Regions associated with this image.
      attr_accessor :regions


      #
      # Mapper for Image class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Image',
          type: {
            name: 'Composite',
            class_name: 'Image',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              created: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'created',
                type: {
                  name: 'DateTime'
                }
              },
              width: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'width',
                type: {
                  name: 'Number'
                }
              },
              height: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'height',
                type: {
                  name: 'Number'
                }
              },
              resized_image_uri: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'resizedImageUri',
                type: {
                  name: 'String'
                }
              },
              thumbnail_uri: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'thumbnailUri',
                type: {
                  name: 'String'
                }
              },
              original_image_uri: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'originalImageUri',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'tags',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ImageTagElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ImageTag'
                      }
                  }
                }
              },
              regions: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'regions',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ImageRegionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ImageRegion'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
